application/urls.py
from django.contrib import admin
from django.urls import path, include

from .views import api as api_views
from .views import pages as pages_views


api_urlpatterns = [
    path("list/", api_views.ApplicationListAPIView.as_view(), name="create"),
    path("create/", api_views.ApplicationCreateAPIView.as_view(), name="create"),
    path("<int:id>/update/", api_views.ApplicationUpdateAPIView.as_view(), name="update"),

]

urlpatterns = [
    path("", pages_views.ApplicationListView.as_view(), name="list"),
    path("create/", pages_views.ApplicationCreateView.as_view(), name="create"),
    path("<int:id>/", pages_views.ApplicationDetailView.as_view(), name="detail"),
    path("<int:id>/edit/", pages_views.ApplicationEditView.as_view(), name="edit"),
    path("api/", include((api_urlpatterns, "application"), namespace="api"))
]

tickets/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path("", include(("application.urls", "application"), namespace="application")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL,
                          document_root=settings.STATIC_ROOT)

application/models.py
from django.db import models
from django.shortcuts import reverse

from . import validators


class Application(models.Model):
    STATUS_CHOICES = (
        ("open", "Open"),
        ("noffer", "Needs Offer"),
        ("offered", "Offered"),
        ("approved", "Approved"),
        ("inprogress", "In Progress"),
        ("ready", "Ready"),
        ("verified", "Verified"),
        ("closed", "Closed"),
    )

    created = models.DateTimeField(auto_now_add=True, blank=True)
    name = models.CharField(max_length=64, verbose_name="Наименование")
    image = models.ImageField(upload_to="images/applications/", verbose_name="Изображение", null=True, blank=True)
    text = models.TextField(verbose_name="Текст")
    till_date = models.DateField(verbose_name="Дата завершения", validators=[validators.validate_date_from_today])
    status = models.CharField(choices=STATUS_CHOICES, max_length=22, verbose_name="Статус")

    def __str__(self):
        return self.name
    
    def get_absolute_url(self):
        print(self)
        return reverse("application:detail", kwargs={"id": self.id})
    
    def get_edit_url(self):
        return reverse("application:edit", kwargs={"id": self.id})
    
    class Meta:
        ordering = ['id']

application/forms.py
from django import forms
from django.utils.safestring import mark_safe

from .models import Application


class SpanWidget(forms.Widget):

    def render(self, name, value, attrs=None, **kwargs):
        return mark_safe("<span>%s</span>" % (self.original_value))

    def value_from_datadict(self, data, files, name):
        if data:
            return None
        return self.original_value


class SpanField(forms.Field):

    def __init__(self, *args, **kwargs):
        kwargs['widget'] = kwargs.get('widget', SpanWidget)
        super().__init__(*args, **kwargs)


class Readonly(object):

    class ReadOnlyMeta:
        read_only = tuple()

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        read_only = self.ReadOnlyMeta.read_only
        instance = kwargs.get("instance", None)
        if not read_only:
            return
        for name in read_only:
            field = self.fields[name]
            if not instance:
                del self.fields[name]
            field.widget = SpanWidget()
            label = self.Meta.labels.get(name, None)
            field.required = False
            field.value = None
            if label:
                field.label = label
            elif not isinstance(field, SpanField):
                continue
            field.widget.original_value = str(getattr(self.instance, name))


class ApplicationModelForm(Readonly, forms.ModelForm):
    created = forms.DateField(required=False)

    class Meta:
        model = Application
        fields = "__all__"
        labels = {"created": "Дата Создания"}
    
    class ReadOnlyMeta:
        read_only = ("created", )

application/views/api.py
import logging

from rest_framework import generics
from rest_framework.exceptions import ValidationError

from .. import models
from .. import serializers
from ..utils import get_or_none, slice_by_count


logger = logging.getLogger(__name__)


class ApplicationCreateAPIView(generics.CreateAPIView):
    queryset = models.Application.objects.all()
    serializer_class = serializers.ApplicationSerializer


class ApplicationUpdateAPIView(generics.UpdateAPIView):
    queryset = models.Application.objects.all()
    serializer_class = serializers.ApplicationSerializer
    lookup_field = "id"


class ApplicationListAPIView(generics.ListAPIView):
    serializer_class = serializers.ApplicationSerializer
    request_serializer_class = serializers.ApplicationListSerializer
    http_method_names = ["post"]

    def get_queryset(self):
        request_serializer = self.request_serializer_class(data=self.request.data)
        if request_serializer.is_valid():
            logger.info(f"Requested data {request_serializer.validated_data} is valid")
            queryset = slice_by_count(models.Application.objects.filter(id__gte=request_serializer.validated_data["id"]), request_serializer.validated_data["count"])
            return queryset
        else:
            logger.info(f"Requested data {self.request.data} is not-valid")
            raise ValidationError({"error":"Not provided needed data"})
        
    
    def post(self, request, *args, **kwargs):
        return self.list(request, *args, **kwargs)

application/views/pages.py
import logging

from django.shortcuts import render
from django.views.generic import ListView, CreateView, DetailView, UpdateView
from django.contrib import messages

from .. import models
from .. import forms as application_forms
from .. import mixins


logger = logging.getLogger(__name__)


class ApplicationDetailView(DetailView):
    template_name = "application/detail.html"
    model = models.Application
    context_object_name = "object"
    pk_url_kwarg = "id"
    form_class = application_forms.ApplicationModelForm
    form_context_name = "form"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        instace = context[self.context_object_name]
        form = self.form_class(instance=instace)
        context[self.form_context_name] = form
        return context


class ApplicationListView(mixins.OrderingByViewMixin, ListView):
    template_name = "application/list.html"
    context_object_name = "objects"
    paginate_by = 2
    model = models.Application
    ordering_kwarg = "order"
    page_kwarg = "page"
    allowed_sort_fields = ["created", "name", "till_date"]


class ApplicationCreateView(CreateView):
    template_name = "application/detail.html"
    model = models.Application
    context_object_name = "object"
    pk_url_kwarg = "id"
    form_class = application_forms.ApplicationModelForm
    form_context_name = "form"
    extra_context = {"create": True}

    def form_valid(self, form):
        result = super().form_valid(form)
        messages.add_message(
        self.request, messages.SUCCESS, "Заявка добавлена")
        logger.info("Заявка добавлена")
        return result

    def form_invalid(self, form):
        result = super().form_valid(form)
        messages.add_message(
            self.request, messages.ERROR, "Ошибка при сохранении завки")
        logger.info("Ошибка при сохранении завки")
        return result


class ApplicationEditView(UpdateView):
    template_name = "application/detail.html"
    model = models.Application
    context_object_name = "object"
    pk_url_kwarg = "id"
    form_class = application_forms.ApplicationModelForm
    form_context_name = "form"
    extra_context = {"edit": True}

    def form_valid(self, form):
        result = super().form_valid(form)
        messages.add_message(
        self.request, messages.SUCCESS, "Заявка сохранена")
        logger.info("Заявка сохранена")
        return result

    def form_invalid(self, form):
        result = super().form_valid(form)
        messages.add_message(
            self.request, messages.ERROR, "Ошибка при сохранении завки")
        logger.info("Ошибка при сохранении завки")
        return result

application/templates/application/base.html
{% load staticfiles %}

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>
        {% block title %}
        Заявки на обработку.
        {% endblock title %}
    </title>
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.7.2/css/all.css" integrity="sha384-fnmOCqbTlWIlj8LyTjo7mOUStjsKC4pOpQbqyi7RrhN7udi9RwhKkMHpvLbHG9Sr" crossorigin="anonymous">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    {% block post_meta %}

    {% endblock post_meta %}
</head>
<body class="bg-light">
    {% block body %}
    <div class="container">
        <div class="py-5 text-center">
            <a href="{% url 'application:list' %}">
                <img class="d-block mx-auto mb-4" src="{% static 'application/images/logo.png' %}" alt="" width="72" height="50">
            </a>
            <h2>
                {% block page_header %}
                Список Заявок
                {% endblock page_header %}
            </h2>
            <p class="lead">Тестовое Задание на должность Python разработчика.</p>
        </div>
        {% include "application/utils/messages.html" %}
        <div class="row">
            {% block content %}

            {% endblock content %}
        </div>
    </div>
    {% endblock body %}
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    {% block post_body %}
    
    {% endblock post_body %}
</body>
</html>

application/templates/application/detail.html
{% extends "application/base.html" %}
{% load staticfiles %}

{% block post_meta %}
    {{super}}
    {% if edit or create %}
    <link href="{% static 'application/css/datepicker.min.css' %}" rel="stylesheet" type="text/css">
    {% endif %}
{% endblock post_meta %}


{% block content %}
<div class="col-md-8">
    <h4 class="mb-3">
        {% if edit %}
            Заявка: {{form.instance.name}} (<a href="{{form.instance.get_absolute_url}}">Отмена</a>)
        {% elif create %}
            Создание Заявки
        {% else %}
            Заявка: {{form.instance.name}} (<a href="{{form.instance.get_edit_url}}">Редактировать</a>)
        {% endif %}
    </h4>
    <form class="needs-validation" novalidate
        action="{% if edit %} {{form.instance.get_edit_url}} {% elif create %} {% url 'application:create' %} {% endif %}"
        method="POST" enctype="multipart/form-data">
        {% for field in form %}
            {% include "application/utils/field.html" with edit=edit create=create field=field form=form %}
        {% endfor %}
        {% if create or edit %}
            {% csrf_token %}
            <hr class="mb-4">
            <button class="btn btn-primary btn-lg btn-block mb-5" type="submit">
                Сохранить
            </button>
        {% endif %}
    </form>
</div>
{% endblock content %}

{% block post_body %}
    {{super}}
    {% if edit or create %}
    <script src="https://cdn.ckeditor.com/ckeditor5/11.2.0/classic/ckeditor.js"></script>
    <script src="{% static 'application/js/edit.js' %}"></script>
    <script src="{% static 'application/js/datepicker.min.js' %}"></script>
    {% endif %}
{% endblock post_body %}

application/templates/application/fields/editorfield.html
{% if edit or create %}
<textarea name="{{field.name}}" id="editor" class="d-none">
    {% if field.value %} {{field.value|safe}} {% endif %}
</textarea>
{% else %}
{{field.value|safe}}
{% endif %}

application/templates/application/fields/imagefield.html
{% if field.value %}
    <img src="{{field.value.url}}" class="img-fluid" alt="">
{% elif not create %}
    <h6 class="d-block">Нету</h6>
{% endif %}
{% if not field.required  and edit %}
<div class="d-block w-100">
    <label for="{{ field.name }}-clear"> Очистить </label>
    <input type="checkbox" name="{{ field.name }}-clear" id="{{ field.name }}-clear_id">
</div>
{% endif %}
{% if edit or create %}
<input type="file" name="{{field.name}}" accept="image/*" id="id_{{field.name}}" class="d-block w-100">
{% endif %}

application/templates/application/list.html
{% extends "application/base.html" %}
{% load query_parametrs %}

{% block content %}
<div class="col-md-8">
    <h4 class="mb-3">
        Список заявок
    </h4>
    <a href="?page=1">Сбросить</a>

    <table class="table">
        <thead>
            <tr>
                <th>Наименование
                    <a href="{% add_query_params request order='name' %}"><i class="fas fa-angle-up ml-1"></i></a>
                    <a href="{% add_query_params request order='-name' %}"><i class="fas fa-angle-down ml-1"></i></a>
                </th>
                <th>Дата завершения
                    <a href="{% add_query_params request order='till_date' %}"><i class="fas fa-angle-up ml-1"></i></a>
                    <a href="{% add_query_params request order='-till_date' %}"><i class="fas fa-angle-down ml-1"></i></a>
                </th>
                <th>Дата создания
                    <a href="{% add_query_params request order='created' %}"><i class="fas fa-angle-up ml-1"></i></a>
                    <a href="{% add_query_params request order='-created' %}"><i class="fas fa-angle-down ml-1"></i></a>
                </th>
            </tr>
        </thead>
        <tbody>
            {% for object in objects %}
            <tr>
                <td>
                    <a href="{{object.get_absolute_url}}">{{object.name}}</a>
                </td>
                <td>{{object.till_date}}</a></td>
                <td>{{object.created}}</td>
            </tr>
            {% endfor %}
        </tbody>
    </table>
</div>
<div class="w-100"></div>
<ul class="pagination d-block">
    {% if page_obj.has_previous  %}
    <li class="page-item"><a class="page-link"  href="{% add_query_params request page=page_obj.previous_page_number %}">Назад</a></li>
    {% endif %}
    {% if page_obj.has_next %}
    <li class="page-item"><a class="page-link"  href="{% add_query_params request page=page_obj.next_page_number %}">Следующий</a></li>
    {% endif %}
</ul>
{% endblock content %}

application/templates/application/utils/field.html
{% load widget_tweaks %}

<div class="mb-3">
    <label for="{{field.name}}">{{field.label}}</label>
    <div class="input-group">
        {% if field|field_type == "imagefield" %}
            {% include "application/fields/imagefield.html" with edit=edit create=create field=field instance=instance %}
        {% elif field.name == "text" %}
            {% include "application/fields/editorfield.html" with edit=edit create=create field=field instance=instance %}        
        {% elif field.name == "till_date" %}
            {% if edit or create %}
                {{field|attr:"id:date-picker"}}
            {% else %}
                {{field.value}}
            {% endif %}
        {% elif field.name == "status" %}
            {% if create or edit %}
                {{field}}
            {% else %}
                <h6>{{form.instance.get_status_display }}</h6>
            {% endif %}
        {% else %}
            {% if create or edit %}
                {{field}}
            {% else %}
               <h6>
                   {% if field.value %}
                        {{field.value}}
                   {% else %}
                        {{field}}
                    {% endif %}
               </h6>
            {% endif %}
        {% endif %}
        {% for error in field.errors %}
            <div class="mt-2 alert alert-danger" style="width: 100%;">
                {{error}}
            </div>
        {% endfor %}
    </div>
</div>

application/templates/application/utils/messages.html
{% load message_tags %}

{% if messages %}
    {% for message in messages %}
        <div class="alert alert-{{message.tags|filter_messge_tags }}" role="alert">
            {{message}}
        </div>
    {% endfor %}
{% endif %}